<?php
/*
Plugin Name: MyCTR
Plugin URI: http://www.pagasa.net/plugin-wordpress-de-gestion-des-mots-cles/
Description: Voir le trafic en provenance de Google et creer des campagnes par mot cle.
Author: Thibaut Maquet
Version: 1.1
Author URI: http://www.pagasa.net/
*/

//
// 24-avr-2011: Version 1.1
//
// 20-avr-2011:
//	- Ajout de la date dans le panneau des mots cles
//	- Ajout du classement des mots cles par article
//	- Ajout du classement general des mots cles 
//
// 19-avr-2011:
//	- Filtre sur les requetes redondantes
//	- Ajout du filtre sur l'activite
//
// 17-avr-2011: 
//	- Bug sur les antishlashes
//	- Ajout de l'activite
//
// 16-avr-2011: Version 1.0

function pk_init() {
  require_once(ABSPATH . 'wp-admin/includes/upgrade.php');

  global $wpdb;

  $tname = $wpdb->prefix . "pk_kw";
  if($wpdb->get_var("SHOW TABLES LIKE '$tname'") != $tname) {
    $sql = "CREATE TABLE " . $tname . " (
    `id` int(11) NOT NULL auto_increment,
    `kw` varchar(120) NOT NULL default '',
    `ts` varchar(20) NOT NULL default '',
    `ts2` varchar(20) NOT NULL default '',
    `postid` varchar(10) NOT NULL default '',
    `opt` varchar(2) NOT NULL default '',
    `cid` int(11) NOT NULL  default '',
    `gid` int(11) NOT NULL  default '',
    PRIMARY KEY  (`id`)
    );";
    dbDelta($sql);
  }

  $tname = $wpdb->prefix . "pk_camp";
  if($wpdb->get_var("SHOW TABLES LIKE '$tname'") != $tname) {
    $sql = "CREATE TABLE " . $tname . " (
    `id` int(11) NOT NULL auto_increment,
    `name` varchar(20) NOT NULL default '',
    `kw` varchar(50) NOT NULL default '',
    `ads` text NOT NULL,
    `link` varchar(100) NOT NULL default '',
    `opt` varchar(2) NOT NULL default '',
    `misc` varchar(100) NOT NULL default '',
    PRIMARY KEY  (`id`)
    );";
    dbDelta($sql);
  }

  $tname = $wpdb->prefix . "pk_ip";
  if($wpdb->get_var("SHOW TABLES LIKE '$tname'") != $tname) {
    $sql = "CREATE TABLE " . $tname . " (
    `ip` varchar(30) NOT NULL default '',
    `ts` varchar(20) NOT NULL default '',
    PRIMARY KEY  (`ip`)
    );";
    dbDelta($sql);
  }

  add_option('pk_prefs_article','20','','yes');
  add_option('pk_prefs_purge','1','','yes');
  add_option('pk_prefs_purge_day','20','','yes');
  add_option('pk_prefs_sortop','0','','yes');

}


function pk_deinit() {
  delete_option('pk_prefs_article');
  delete_option('pk_prefs_purge');
  delete_option('pk_prefs_purge_day');
  delete_option('pk_prefs_sortop');
}

function pk_filter($mct) {
  $mc = "";
  $mref=$_SERVER["HTTP_REFERER"];
  if(strlen($mref)) {
    $q=strstr($mref,".google.");
    if(strlen($q)) {
      $tab=array();
      $q=strstr($mref,"&q=");
      if(strlen($q))
        $tab=split("&q=",$mref);
      else {
        $q=strstr($mref,"?q=");
        if(strlen($q))
          $tab=split("\?q=",$mref);
      }

      if(strlen($tab[1])) {
        $tab=split("&",$tab[1]);
        if(strlen($tab[0])) {
          global $wpdb;
          $mip = getenv('REMOTE_ADDR');
          $mi = $wpdb->get_var("SELECT COUNT(*) FROM ".$wpdb->prefix . "pk_ip WHERE ip = '".$mip."'");
          if(!$mi) {
            $sql = "INSERT INTO ".$wpdb->prefix . "pk_ip ( `ip`,`ts`) VALUES ('".$mip."','".mktime()."')";
            $wpdb->query($sql);
            $mkwse = urldecode($tab[0]);
            $mt = mktime();
            $sql = "INSERT INTO ".$wpdb->prefix . "pk_kw ( `kw`,`ts`,`postid`) VALUES ('".$mkwse."','".$mt."','".get_the_ID()."')";
            $wpdb->query($sql);
            $sql = $wpdb->get_results("SELECT id FROM ".$wpdb->prefix . "pk_kw WHERE ts = '".$mt."' AND kw = '".$mkwse."'");
            foreach ($sql as $res) {
              $mid = $res->id;
            }
            $sql = $wpdb->get_results("SELECT * FROM ".$wpdb->prefix . "pk_camp");
            foreach ($sql as $res) {
              $mkwcamp = $res->kw;
              $mk = explode(" ",$mkwcamp);
              $j = count($mk);
              $i = 0;
              foreach($mk as $li) {
                if(strstr($mkwse,$li))
                  $i++;
              }
              if($i>=$j) {
                $mads = stripslashes(base64_decode($res->ads));
                $mcid = $res->id;
                $mc = '<a href="http://'.getenv("HTTP_HOST")."/ck.php?id1=".$mcid."&id2=".$mid."&ts=".$mt.'">'.$mads."</a>\n";
                $sql = "UPDATE ".$wpdb->prefix . "pk_kw SET `cid` = '".$mcid."' WHERE `ts` = '".$mt."' AND `kw` = '".$mkwse."'";
                $wpdb->query($sql);
              }
            }
       
            $mpurge = get_option('pk_prefs_purge');
            if(strlen($mpurge)) {
              $mts = get_option('pk_prefs_purge_day');
              $mts =  mktime() - (60 * 60 * 24 * $mts);
              $sql = "DELETE FROM ".$wpdb->prefix . "pk_kw WHERE ts < ".$mts;
              $wpdb->query($sql);
            }
          }
        }
        $mts =  mktime() - (60 * 5);
        $sql = "DELETE FROM ".$wpdb->prefix . "pk_ip WHERE ts < ".$mts;
        $wpdb->query($sql);
      }
    }
  }
  $mct = $mc . $mct;
  return $mct;
}

function pk_admin_settings() {
  if (function_exists('add_options_page')){
    add_options_page("MyCTR", "MyCTR", 'manage_options', 'myctr-pid', "pk_display_settings");
  }
}

function pk_admin_del($mid) {
  global $wpdb;
  $sql = "DELETE FROM ".$wpdb->prefix . "pk_camp WHERE id = ".$mid;
  $wpdb->query($sql);
  $sql = "UPDATE ".$wpdb->prefix . "pk_kw SET `cid` = '0',`gid` = '0' WHERE `cid` = '".$mid."'";
  $wpdb->query($sql);
  return pk_admin_menu("La campagne a &eacute;t&eacute; supprim&eacute;e");
}

function pk_admin_update($mid) {
  global $wpdb;
  $mrequrl = $_SERVER['REQUEST_URI'];
  $mrequrl = preg_replace("/\&op=(.*)+/","",$mrequrl);

  $sql = $wpdb->get_results("SELECT * FROM ".$wpdb->prefix . "pk_camp WHERE id = ".$mid);
  foreach ($sql as $res) {
    $mname = $res->name;
    $mkw = $res->kw;
    $mads = $res->ads;
    $mlink = $res->link;
  }

  $a ="<h3>Modifier la campagne</h3>";

  $a .= "<table>";
  $a .= '<form action="'.$mrequrl."&op=mod&id=".$mid.'" method="post">';
  $a .= "<tr><td>";
  $a .= "Nom : ";
  $a .= '<input type="text" size="20" maxlength="20" name="nom" value="'.$mname.'">';
  $a .= "</td></tr>";
  $a .= "<tr><td>";
  $a .= "Mot cl&eacute; : ";
  $a .= '<input type="text" size="50" maxlength="100" name="kw" value="'.$mkw.'">';
  $a .= "</td></tr>";
  $a .= "<tr><td>";
  $a .= "Texte de l'annonce : ";
  $a .= "</td></tr>";
  $a .= '<tr><td><textarea rows="3" cols="100" name="ads">'.stripslashes(base64_decode($mads)).'</textarea>';
  $a .= "</td></tr>";
  $a .= "<tr><td>";
  $a .= "Lien de l'annonce : ";
  $a .= '<input type="text" size="50" maxlength="100" name="link" value="'.$mlink.'">';
  $a .= "</td></tr>";
  $a .= "<tr><td>";
  $a .= '<input type="submit" value="Modifier">';
  $a .= "</td></tr>";
  $a .= "</form>";
  $a .= "</table>";

  echo $a;
}

function pk_admin_mod($mid) {
  if(isset($_POST['nom'])){
    $mname = $_POST['nom'];
    if(!strlen($mname))
      return pk_admin_menu("Il manque le nom de la campagne");
    if(isset($_POST['kw'])){
      $mkw = $_POST['kw'];
      if(!strlen($mkw))
        return pk_admin_menu("Il manque le mot cl&eacute; de la campagne");
      if(isset($_POST['ads'])){
        $mads = $_POST['ads'];
        if(!strlen($mads))
          return pk_admin_menu("Il manque l'annonce");
        if(isset($_POST['link'])){
          $mlink = $_POST['link'];
          if(!strlen($mlink))
            return pk_admin_menu("Il manque le lien de l'annonce");
          global $wpdb;
          $mads = base64_encode($mads);
          $sql = "UPDATE ".$wpdb->prefix . "pk_camp SET `name` = '".$mname."',`kw` = '".$mkw."',`ads` = '".$mads."',`link` = '".$mlink."' WHERE `id` = '".$mid."'";
          $wpdb->query($sql);
          return pk_admin_menu("La campagne a &eacute;t&eacute; modifi&eacute;e");
        }
        else
          return pk_admin_menu("Il manque le lien de l'annonce");
      }
      else
        return pk_admin_menu("Il manque l'annonce");
    }
    else
      return pk_admin_menu("Il manque le mot cl&eacute; de la campagne");
  }
  else
    return pk_admin_menu("Il manque le nom de la campagne");
}

function pk_admin_add() {
  if(isset($_POST['nom'])){
    $mname = $_POST['nom'];
    if(!strlen($mname))
      return pk_admin_menu("Il manque le nom de la campagne");
    if(isset($_POST['kw'])){
      $mkw = $_POST['kw'];
      if(!strlen($mkw))
        return pk_admin_menu("Il manque le mot cl&eacute; de la campagne");
      if(isset($_POST['ads'])){
        $mads = $_POST['ads'];
        if(!strlen($mads))
          return pk_admin_menu("Il manque l'annonce");
        if(isset($_POST['link'])){
          $mlink = $_POST['link'];
          if(!strlen($mlink))
            return pk_admin_menu("Il manque le lien de l'annonce");   
          global $wpdb;
          $mads = base64_encode($mads);
          $sql = "INSERT INTO ".$wpdb->prefix . "pk_camp ( `name`,`kw`,`ads`,`link`,`opt`) VALUES ('".$mname."','".$mkw."','".$mads."','".$mlink."','1')";
          $wpdb->query($sql);
          return pk_admin_menu("La campagne est enregistr&eacute;e");
        }
        else
          return pk_admin_menu("Il manque le lien de l'annonce");
      }
      else
        return pk_admin_menu("Il manque l'annonce");
    }
    else
      return pk_admin_menu("Il manque le mot cl&eacute; de la campagne");
  }
  else
    return pk_admin_menu("Il manque le nom de la campagne");
}

//
// Status
//

function pk_admin_status($mout) {

  $a = "";
  if(strlen($mout)) {
    $a .= "<h3>Status</h3>\n";
    $a .= '<table style="border: #cccccc 1px outset;" border="1" cellspacing="1" cellpadding="3" width="75%">'."\n";
    $a .= "<tr><td>\n";
    $a .= $mout;
    $a .= "</td></tr></table>\n";
  }
  return $a;
}

function pk_clic($mid) {
  global $wpdb;
  $a = "<h3>Statistiques sur les clics</h3>";
  $a .= '<table style="border: #cccccc 1px solid;" border="1" cellspacing="1" cellpadding="3">';
  $a .= "<tr><td><center><b>Date</b></center></td><td><center><b>Mots cl&eacute;s</b></center></td><td><center><b>Cliqu&eacute; le </b></center></td></tr>";
  $sql = $wpdb->get_results("SELECT * FROM ".$wpdb->prefix . "pk_kw WHERE gid = ".$mid." ORDER BY ts DESC");
  foreach ($sql as $res) {
    $a . "<tr>";
    $a .= "<td>".strftime("%d/%m/%G %Hh%M",$res->ts)."&nbsp;&nbsp;-&nbsp;&nbsp;</td>";
    $a .= "<td>".$res->kw."&nbsp;&nbsp;-&nbsp;&nbsp;</td>";
    $a .= "<td>".strftime("%d/%m/%G %Hh%M",$res->ts2)."&nbsp;&nbsp;</td>";
    $a .= "</tr>";
  }
  $a .= "</table>";
  echo $a;
}

function pk_print($mid) {
  global $wpdb;
  $a = "<h3>Statistiques sur les impressions</h3>";
  $a .= '<table style="border: #cccccc 1px solid;" border="1" cellspacing="1" cellpadding="3">';
  $a .= "<tr><td><center><b>Date</b></center></td><td><center><b>Mots cl&eacute;s</b></center></td></tr>";
  $sql = $wpdb->get_results("SELECT * FROM ".$wpdb->prefix . "pk_kw WHERE cid = ".$mid." ORDER BY ts DESC");
  foreach ($sql as $res) {
    $a . "<tr>";
    $a .= "<td>".strftime("%d/%m/%G %Hh%M",$res->ts)."&nbsp;&nbsp;-&nbsp;&nbsp;</td>";
    $a .= "<td>".$res->kw."</td>";
    $a .= "</tr>";
  }
  $a .= "</table>";
  echo $a;
}

function pk_admin_menu($mout) {
  global $wpdb;

  $mrequrl = $_SERVER['REQUEST_URI'];
  $mrequrl = preg_replace("/\&op=(.*)+/","",$mrequrl);
  $mrequrl = preg_replace("/\&st=(.*)+/","",$mrequrl);

  if(strlen($mout))
    echo pk_admin_status($mout);

// Stats sur les mot cle

  $mp = get_option('pk_prefs_sortop');
  if($mp)
    $mst = 0;
  else
    $mst = 1;

  $date = sprintf("%4d-%02d-%02d",date('Y'),date('n'), date('d'));
  $dt = strtotime($date);

  $nb = get_option('pk_prefs_article');
  $a = "<h3>Statistiques sur les mots cl&eacute;s</h3>";
  $a .= '<table style="border: #cccccc 1px solid;" border="1" cellspacing="1" cellpadding="3">';
  $a .=" <tr><td><center><b>Date</b></center></td><td><center><b>Article</b></center></td><td><center><b><a href=".'"'.$mrequrl."&op=kwv".'"'.">Mots cl&eacute;s&nbsp;&nbsp;&nbsp;</a></b></center></td><td><center><b><a href=".'"'.$mrequrl."&st=".$mst.'"'.">Activit&eacute;</a></b></center></td></tr><tr>";
  if($mst) 
    $sql = $wpdb->get_results("SELECT postid, COUNT(postid) FROM `wp_pk_kw` WHERE ts > '".$dt."' GROUP BY postid ORDER BY 2 DESC LIMIT ".$nb);
  else
    $sql = $wpdb->get_results("SELECT postid,COUNT(postid) FROM ".$wpdb->prefix . "pk_kw GROUP BY postid ORDER BY 2 DESC LIMIT ".$nb);
  foreach ($sql as $res) {
    $mpost = get_post($res->postid);
    $mc = $wpdb->get_var("SELECT COUNT(*) FROM ".$wpdb->prefix . "pk_kw WHERE postid = ".$res->postid);
    $md = $wpdb->get_var("SELECT COUNT(*) FROM ".$wpdb->prefix . "pk_kw WHERE postid = ".$res->postid." AND ts > '".$dt."'");
    $a .= "<tr>";
    $a .= "<td>".strftime("%d/%m/%Y %Hh%M",strtotime($mpost->post_date))."&nbsp;&nbsp;&nbsp;</td>";
    $a .= '<td><a href="http://'.getenv("HTTP_HOST").'/?p='.$res->postid.'" target="_blank">'.$mpost->post_title.'</a></td><td><a href="'.$mrequrl."&op=kws&id=".$res->postid.'"><center>'.$mc."</center></a></td><td><center>".$md."</center></td>";
    $a .= "</tr>\n";
  }
  $a .= "</tr></table>";

// Stats sur les campagnes

  $a .="<h3>Statistiques sur les campagnes</h3>";
  $a .= '<table style="border: #cccccc 1px solid;" border="1" cellspacing="1" cellpadding="3">';
  $sql = $wpdb->get_results("SELECT id,name FROM ".$wpdb->prefix . "pk_camp");
  $a .= "<tr><td><center><b>Nom</b></center></td><td><center><b>Clics&nbsp;&nbsp;&nbsp;</b></center></td><td><center><b>Impressions&nbsp;&nbsp;</b></center></td><td><center><b>CTR&nbsp;&nbsp;&nbsp;</b></center></td><td><center><b>Actions</b></center></td></tr>\n";
  foreach ($sql as $res) {
    $mid = $res->id;
    $a .= "<tr>";
    $a .= "<td>".$res->name."&nbsp;&nbsp;</td>\n";
    $mb = $wpdb->get_var("SELECT COUNT(*) FROM ".$wpdb->prefix . "pk_kw WHERE gid = ".$mid);
    $a .= "<td><center>";
    $a .= '<a href="'.$mrequrl."&op=kwc&id=".$mid.'">'.$mb."</a>";
    $a .= "</center></td>\n";
    $mc = $wpdb->get_var("SELECT COUNT(*) FROM ".$wpdb->prefix . "pk_kw WHERE cid = ".$mid);
    $a .= "<td><center>";
    $a .= '<a href="'.$mrequrl."&op=kwp&id=".$mid.'">'.$mc."</a>&nbsp;&nbsp;";
    $a .= "</center></td>\n";
    $mctr = $mb/$mc*100;
    $mctr = sprintf("%.2f",$mctr);
    $a .= "<td><center>".$mctr."%&nbsp;&nbsp;&nbsp;&nbsp;</center></td>";
    $a .= '<td>';
    $a .= '<a href="'.$mrequrl."&op=del&id=".$mid.'"'.">Supprimer</a>&nbsp;&nbsp;&nbsp;";
    $a .= '<a href="'.$mrequrl."&op=upd&id=".$mid.'"'.">Modifier</a>";
    $a .= "</td>\n";
    $a .="</tr>";
  }
  $a .= "</table>";

// Ajouter une campagne

  $a .="<h3>Ajouter une campagne</h3>";

  $a .= "<table>";
  $a .= '<form action="'.$mrequrl."&op=add".'" method="post">';
  $a .= "<tr><td>";
  $a .= "Nom : ";
  $a .= '<input type="text" size="20" maxlength="20" name="nom">';
  $a .= "</td></tr>";
  $a .= "<tr><td>";
  $a .= "Mot cl&eacute; : ";
  $a .= '<input type="text" size="50" maxlength="100" name="kw">';
  $a .= "</td></tr>";
  $a .= "<tr><td>";
  $a .= "Texte de l'annonce : ";
  $a .= "</td></tr>";
  $a .= '<tr><td><textarea rows="3" cols="100" name="ads"></textarea>';
  $a .= "</td></tr>";
  $a .= "<tr><td>";
  $a .= "Lien de l'annonce : ";
  $a .= '<input type="text" size="50" maxlength="100" name="link" value="http://">';
  $a .= "</td></tr>";
  $a .= "<tr><td>";
  $a .= '<input type="submit" value="Ajouter">';
  $a .= "</td></tr>";
  $a .= "</form>";
  $a .= "</table>";

// Preferences
  $mpurge = get_option('pk_prefs_purge');
  if(strlen($mpurge))
    $mpurgetxt = "checked";
  else
    $mpurgetxt = "";

  $mpurgeday = get_option('pk_prefs_purge_day');
  $marticle = get_option('pk_prefs_article');

  $a .= "<h3>Pr&eacute;f&eacute;rences</h3>";
  $a .= "<table>";
  $a .= '<form action="'.$mrequrl."&op=prefs".'" method="post">';
  $a .= "<tr><td>";
  $a .= "Afficher ";
  $a .= '<input type="text" size="2" maxlength="2" name="article" value="'.$marticle.'">';
  $a .= " article(s)";
  $a .= "</td></tr>";
  $a .= "<tr><td>";
  $a .= "Purge automatique : ";
  $a .= "</td><td>";
  $a .= '<input type="checkbox" name="purge"'.$mpurgetxt.'>';
  $a .= " tous les ";
  $a .= '<input type="text" size="2" maxlength="2" name="purgeday" value="'.$mpurgeday.'">';
  $a .= " jour(s)";
  $a .= "</td></tr>";
  $a .= "<tr><td>";
  $a .= '<input type="submit" value="Modifier">';
  $a .= "</td></tr>";
  $a .= "</form>";
  $a .= "</table>";

  $a .= "<br />";
  $a .= "<table>";
  $a .= "<tr><td>";
  $a .= '<center>(C)2011 <a href="http://www.pagasa.net" target="_blank">Thibaut Maquet</a></center>';
  $a .= "</td></tr>";
  $a .= "</table>";
  echo $a;
}

function pk_admin_prefs_save() {
  if(isset($_POST['purge']))
    add_option('pk_prefs_purge','1','','yes');
  else
    delete_option('pk_prefs_purge');

  if(isset($_POST['purgeday'])) {
    $mrs = $_POST['purgeday'];
    if($mrs < 1 || $mrs > 99)
      return pk_admin_menu("Erreur sur la purge");
    update_option('pk_prefs_purge_day',$mrs);
  }

  if(isset($_POST['article'])) {
    $mrs = $_POST['article'];
    if($mrs < 1 || $mrs > 99)
      return pk_admin_menu("Erreur sur le nombre d'articles");
    update_option('pk_prefs_article',$mrs);
  }

  pk_admin_menu("Pr&eacute;f&eacute;rences enregistr&eacute;es");

}

function pk_admin_kws($mid) {
  global $wpdb;

  $mrequrl = $_SERVER['REQUEST_URI'];
  $mrequrl = preg_replace("/\&op=(.*)+/","",$mrequrl);
  $mrequrl = preg_replace("/\&id=(.*)+/","",$mrequrl);

  $mpost = get_post($mid);

  $a = "<h3>Statistiques sur l'article '".$mpost->post_title."'</h3>";
  $a .= '<table style="border: #cccccc 1px solid;" border="1" cellspacing="1" cellpadding="3">';
  $a .=" <tr><td><center><b>Date</b></center></td><td><center><b><a href=".'"'.$mrequrl."&op=kww&id=".$mid.'">'."Mots cl&eacute;s</a</b></center></td></tr><tr>";
  $sql = $wpdb->get_results("SELECT * FROM ".$wpdb->prefix . "pk_kw WHERE postid = ".$mid." ORDER BY ts DESC");
  foreach ($sql as $res) {
    $a .= "<tr>";
    $a .= "<td>".strftime("%d/%m/%G %Hh%M",$res->ts)."&nbsp;&nbsp;-&nbsp;&nbsp;</td>";
    $a .= "<td>".$res->kw."</td>";
    $a .= "</tr>\n";
  }
  $a .= "</tr></table>";
  echo $a;
}

function pk_sort($mid) {
  global $wpdb;
  $mkeys = array();
  $sql = $wpdb->get_results("SELECT * FROM ".$wpdb->prefix . "pk_kw WHERE postid = ".$mid." ORDER BY ts DESC");
  foreach ($sql as $res) {
    $mks = explode(" ",$res->kw);
    foreach ($mks as $mk) {
      $mkeys[0][$mk] = $mk;
      $mkeys[1][$mk] = $mkeys[1][$mk]+1;
    }
  }
  $mp = array();
  $i = 0;
  foreach ($mkeys[0] as $res) {
    $mp[0][$i] = $res;
    $mp[1][$i++] = $mkeys[1][$res];  
  }

  for($j=0;$j<$i;$j++) {
    for($k=0;$k<$i;$k++) {
      if($mp[1][$k] < $mp[1][$k+1]) {
        $t1 = $mp[1][$k];
        $mp[1][$k] = $mp[1][$k+1];
        $mp[1][$k+1] = $t1;
        $t1 = $mp[0][$k];
        $mp[0][$k] = $mp[0][$k+1];
        $mp[0][$k+1] = $t1;
      }
    }
  }

  $a = "<h3>Classement des mots cl&eacute;s</h3>";
  $a .= '<table style="border: #cccccc 1px solid;" border="1" cellspacing="1" cellpadding="3">';
  $a .=" <tr><td><center><b>Mots cl&eacute;s</b></center></td><td><center><b>Nombre</b></center></td></tr><tr>";

  for($l=0;$l<$i;$l++) {
    $a .= "<tr><td>".$mp[0][$l]."</td><td><center>".$mp[1][$l]."</center></td></tr>\n";
  }

  $a .= "</table>";
  echo $a;
}

function pk_main_sort() {
  global $wpdb;
  $mkeys = array();
  $sql = $wpdb->get_results("SELECT * FROM ".$wpdb->prefix . "pk_kw");
  foreach ($sql as $res) {
    $mks = explode(" ",$res->kw);
    foreach ($mks as $mk) {
      $mkeys[0][$mk] = $mk;
      $mkeys[1][$mk] = $mkeys[1][$mk]+1;
    }
  }
  $mp = array();
  $i = 0;
  foreach ($mkeys[0] as $res) {
    $mp[0][$i] = $res;
    $mp[1][$i++] = $mkeys[1][$res];
  }

  for($j=0;$j<$i;$j++) {
    for($k=0;$k<$i;$k++) {
      if($mp[1][$k] < $mp[1][$k+1]) {
        $t1 = $mp[1][$k];
        $mp[1][$k] = $mp[1][$k+1];
        $mp[1][$k+1] = $t1;
        $t1 = $mp[0][$k];
        $mp[0][$k] = $mp[0][$k+1];
        $mp[0][$k+1] = $t1;
      }
    }
  }

  $a = "<h3>Classement des mots cl&eacute;s</h3>";
  $a .= '<table style="border: #cccccc 1px solid;" border="1" cellspacing="1" cellpadding="3">';
  $a .=" <tr><td><center><b>Mots cl&eacute;s</b></center></td><td><center><b>Nombre</b></center></td></tr><tr>";

  for($l=0;$l<$i;$l++) {
    $a .= "<tr><td>".sprintf("%50.50s",$mp[0][$l])."</td><td><center>".$mp[1][$l]."</center></td></tr>\n";
  }

  $a .= "</table>";
  echo $a;

}

function pk_display_settings() {
  $mop = (isset($_GET['op'])) ? $_GET['op'] : "0";
  $mid = (isset($_GET['id'])) ? $_GET['id'] : "0";
  $mst = (isset($_GET['st'])) ? $_GET['st'] : "0";

  update_option('pk_prefs_sortop',$mst);

  switch($mop) {
    case "kws":
      pk_admin_kws($mid);
      break;
    case "prefs":
      pk_admin_prefs_save();
      break;
    case "add":
      pk_admin_add();
      break;
    case "del":
      pk_admin_del($mid);
      break;
    case "upd":
      pk_admin_update($mid);
      break;
    case "mod":
      pk_admin_mod($mid);
      break;
    case "kwp":
      pk_print($mid);
      break;
    case "kww":
      pk_sort($mid);
      break;
    case "kwc":
      pk_clic($mid);
      break;
    case "kwv":
      pk_main_sort();
      break;
    default:
      pk_admin_menu("");
      break;
  }
}

function pk_admin_prefs() {
  $mrequrl = $_SERVER['REQUEST_URI'];
  $mrequrl = preg_replace("/\&op=(.*)+/","",$mrequrl);
}

register_activation_hook(__FILE__,'pk_init');
register_deactivation_hook(__FILE__,'pk_deinit');

add_filter('the_content', 'pk_filter', 25);
add_filter('the_excerpt', 'pk_filter', 25);

add_action('admin_menu', 'pk_admin_settings');
